;********************************************************
;  RC5 IR-Empfnger mit ATtiny2313
;  Copyright (C)  Dipl.Ing. Hans Krause 02.2008
;
;  Hardware :	ATtiny2313
;
;  Main Source file of RC5
;
;Beschreibung:
;An Port PD2 wird ein IR-Empfnger angeschlossen. 
;
;Portbelegung:
;  Port D2  	Eingang			IR-Empfnger
;
;
;nderungen:
;********************************************************
.include "tn2313def.inc"
.include "vectors.inc"
.include "vars.inc"


.include "Serial.asm"
.include "Timers.asm"
.include "Syssetup.asm"

;********************************************************
;**     Programmstart
;********************************************************
Reset:
;set stack pointer
	ldi		temp,low(RAMEND); top of memory
	out		SPL,temp		; init stack pointer
	rcall	systemsetup		; initialize mem, i/o
							;
;Fill Textbuffer with text	;
	ldi		ZH,high(sendline*2)	;Set/Restore pointer to string
	ldi		ZL,low(sendline*2)	;Set/Restore pointer to string
							;
	rcall	SerialOut		;
							;
;set bit register
	ldi		temp,0x04		;
	mov		rc5_bit,temp	;

;Clear RC5 receive register
	clr		temp			;
	sts		rc5_datal,temp	;
	sts		rc5_datah,temp	;
							;
	clr		temp3			;
							;
;********************************************************
;**     Hauptprogramm
;********************************************************
main:						;
;Auffangregister in Arbeitsregister kopieren und dann lschen
	cli						;
	lds		wl,rc5_datal	;
	lds		wh,rc5_datah	;
	clr		temp			;
	sts		rc5_datal,temp	;
	sts		rc5_datah,temp	;
	sei						;
							;
;Arbeitsregister prfen, ob RC5 Signal empfangen
	cpi		wh,0			;
	brne	Ausgabe			;
	cpi		wl,0			;
	breq	main			;
							;
Ausgabe:					;
;Togglebit extrahieren und ausgeben
	mov		temp,wh			;
	lsr		temp			;
	lsr		temp			;
	lsr		temp			;
	andi	temp,0x01		;
	subi	temp,-0x30		;	
	rcall	sendchar		;
	ldi		temp,' '		;
	rcall	sendchar		;
							;
;Adressbits (5 bit) extrahieren und ausgeben
	andi	wh,0x04			;
	mov		temp,wl			;
	andi	temp,0xc0		;
	lsr		temp			;
	rol		wh				;
	lsr		temp			;
	rol		wh				;
	mov		BAlb,wh			;
	rcall	byte2asc		;convert byte in 3 ASCII character
	mov		temp,Asc1		;
	cpi		temp,'0'		;skip leading '0'
	breq	Char2			;
							;
	rcall	sendchar		;
							;
Char2:						;
	mov		temp,Asc2		;
	cpi		temp,'0'		;skip leading '0'
	breq	Char3			;
							;
	rcall	sendchar		;
							;
Char3:						;
	mov		temp,Asc3		;
	rcall	sendchar		;
	ldi		temp,' '		;
	rcall	sendchar		;
							;
;Commandbits (6 bit) extrahieren und ausgeben
	mov		temp,wl			;
	andi	temp,0x3f		;
	mov		BAlb,wl			;
	rcall	byte2asc		;convert byte in 3 ASCII character
	mov		temp,Asc1		;
	cpi		temp,'0'		;skip leading '0'
	breq	Char21			;
							;
	rcall	sendchar		;
							;
Char21:						;
	mov		temp,Asc2		;
	cpi		temp,'0'		;skip leading '0'
	breq	Char31			;
							;
	rcall	sendchar		;
							;
Char31:						;
	mov		temp,Asc3		;
	rcall	sendchar		;
							;
	ldi		ZH,high(sendline*2)	;Set/Restore pointer to string
	ldi		ZL,low(sendline*2)	;Set/Restore pointer to string
							;
	rcall	SerialOut		;
							;
main1:						;
	rjmp	main			;
							;
;********************************************************
