;----------------------------------------------------------------------
; 
; Procedure : systemsetup
; 
; Call to initialize mem, i/o, etc
; 
; Entry : none
; Exit  : With Global interrupts enabled
; Destroys :
; 
;----------------------------------------------------------------------
;systemsetup	proc
;
systemsetup:
;
; - Setup Port D . . .
;
	ldi wl,0b10000111          ;PullUps fr Eingnge
	out portd,wl               ;einschalten 
	com wl                     ;Ein/Ausgnge
	out ddrd,wl                ;setzen

;
; - Setup UART with 10MHz
;
.equ	Baud=19200
.equ	UBRRVAL=Clock/(Baud*16)-1
							;
;UCSRC	 x0000110		;
;         ||||++--------; 11=8 bit
;         |||+----------; 0 =1 stop bit
;         |++-----------; 00=no parity
;		  +-------------; 0 =Async mode
	ldi	wl,0x06
	out	UCSRC,wl			;Load UART control reg
	
	ldi	wl,LOW(UBRRVAL)		;divisor for 19531 baud (0,2% over 19200)
	out	UBRRL,wl			;write baud divisor
	ldi	wl,HIGH(UBRRVAL)	;divisor for 19531 baud (0,2% over 19200)
	out	UBRRH,wl			;write baud divisor
							;
;UCSRB	 00011000	;
;        |||||||+------; 0=TxBit8
;        ||||||+-------; 0=RxBit8
;        |||||+--------; 0=UCSZ2 8 bit
;        ||||+---------; 1=Tx enable
;        |||+----------; 1=Rx enable
;        ||+-----------; 0=DataRegEmptyInt disable
;        |+------------; 0=TxCompleteInt disable
;		 +-------------; 0=RxCompleteInt disable
	ldi	wl,0x18			;UART config byte
	out	UCSRB,wl			;Load UART control reg

							;
;****************************************************************************
; - send welcome message
;
	ldi	ZH,high(welcome*2);Set/Restore pointer to string
	ldi	ZL,low(welcome*2);Set/Restore pointer to string
;						;
	rcall	SerialOut	;
;
;****************************************************************************
;
;
; - Setup Timer 0 . . .
;
						;
;TCCR0A	 xxxxxx11		;
;        ||||  ++-------; WGM01,WGM00	
;        ||++-----------; COM0B1,COM0B0	
;        ++-------------; COM0A1,COM0A0	
	out tccr0a,null           

;TCCR0B	 xxxxx100		;
;        ||  |+++-------; CS02,CS01,CS00    Prescaler auf 256*clock	
;        ||  +----------; WGM02	
;        ++-------------; FOC0A,FOC0B	
	ldi wl,4            ;Vorteiler 1:256
	out tccr0b,wl       ;
						;
						;
	ldi wl,1<<TOIE0     ;TimerOverflow0-Interrupt
	out TIMSK,wl        ;einschalten
						;
	ldi	wl,-2			;set reload value
	mov	reload,wl		;
	out	TCNT0,reload	;
						;
systemsetup_exit:		;
	sei					;enable global ints
	ret					;

;systemsetup	endp
