;----------------------------------------------------------------------
; 
; Procedure : TINT0
; 
; Entered when timer 0 overflows (FF to 00)
; Timer0 is called every 51,2 usec (10Mhz)
; 
; Entry : none
; Exit  : Received word in RAM rc5_datah:rc5_datal
; Destroys :
; 
;----------------------------------------------------------------------
TINT0:
	in		temp1,SREG		;
	push	temp1			;
;**************************************************************
;  TCNT0 = -2;					// 2 * 256 = 512 cycle
;**************************************************************
	out		TCNT0,reload	;
							;
;**************************************************************
;  if( ++rc5_time > PULSE_MAX )
;  {			// count pulse time
;    if( !(tmp & 0x4000) && tmp & 0x2000 )	// only if 14 bits received
;      rc5_data = tmp;
;    tmp = 0;
;  }
;***************************************************************
	inc		rc5_time		;
	mov		temp1,rc5_time	;
	cpi		temp1,PULSE_MAX	;
	brcs	T_C				;
							;
	mov		temp1,shifth	;
	sbrc	temp1,6			;
	rjmp	T_B				;
							;
	mov		temp1,shifth	;
	sbrs	temp1,5			;
	rjmp	T_B				;
							;
	sts		rc5_datah,shifth;
	sts		rc5_datal,shiftl;
							;
T_B:						;
	clr		shifth			;
	clr		shiftl			;
							;
;***************************************************************
;  if( (rc5_bit ^ xRC5_IN) & 1<<xRC5 )
;  {		// change detect
;    rc5_bit = ~rc5_bit;				// 0x00 -> 0xFF -> 0x00
;**************************************************************
T_C:						;
	in		temp1,PIND		;
	andi	temp1,0x04		;
	cp		temp1,rc5_bit	;
	breq	TINT0_exit		;
							;
	mov		rc5_bit,temp1	;
							;
;**************************************************************
;    if( rc5_time < PULSE_MIN )			// to short
;      tmp = 0;
;**************************************************************
T_D:						;
	mov		temp1,rc5_time	;
	cpi		temp1,PULSE_MIN	;
	brcc	T_F				;
							;
T_E:						;
	clr		shifth			;
	clr		shiftl			;
							;
;**************************************************************
;    if( !tmp || rc5_time > PULSE_1_2 )
;	 {		// start or long pulse time
;**************************************************************
T_F:						;
	clr		temp1			;
	cp		shifth,temp1	;
	cpc		shiftl,temp1	;
	breq	T_F3			;
							;
T_F2:						;
	mov		temp1,rc5_time	;
	cpi		temp1,PULSE_1_2	;
	brcs	TINT0_exit		;
							;
;**************************************************************
;      if( !(tmp & 0x4000) )		// not to many bits
;        tmp <<= 1;					// shift
;      if( !(rc5_bit & 1<<xRC5) )	// inverted bit
;        tmp |= 1;					// insert new bit
;      rc5_time = 0;				// count next pulse time
;    }
;  }
;***************************************************************
T_F3:						;
	mov		temp1,shifth	;
	sbrc	temp1,6			;
	rjmp	T_H				;
							;
	clc						;
	rol		shiftl			;
	rol		shifth			;
							;
T_G:						;
	mov		temp1,rc5_bit	;
	sbrc	temp1,2			;
	rjmp	T_H				;
							;
	mov		temp1,shiftl	;
	ori		temp1,0x01		;
	mov		shiftl,temp1	;
							;
T_H:						;
	clr		rc5_time		;
							;
;***************************************************************
;  rc5_tmp = tmp;
;***************************************************************
							;
TINT0_exit:					;	
	pop		temp1			;
	out		SREG,temp1		;
	reti					;


;TINT0	endp


