;======================================================================
;
; vars.inc
;
; Main Include file of the project RC5 Decoder.
;
; Copyright (c) 2008 by Dipl.Ing. Hans Krause
;
;======================================================================

;----------------------------------------------------------------------
; Constants
;----------------------------------------------------------------------
; EQUSTART

.equ 	clock	= 10000000  	;1MHz Taktfrequenz

;.equ	RC5TIME		= 	1.778e-3		;1.778msec
;.equ	PULSE_MIN	=	clock / 512 * RC5TIME * 0.4 + 0.5
;.equ	PULSE_1_2	=	clock / 512 * RC5TIME * 0.8 + 0.5
;.equ	PULSE_MAX	=	clock / 512 * RC5TIME * 1.2 + 0.5

.equ	PULSE_MIN	=	14
.equ	PULSE_1_2	=	28
.equ	PULSE_MAX	=	42


; EQUEND

;----------------------------------------------------------------------
; Register variables
;----------------------------------------------------------------------
; REGVARSTART

.def 	reload	= r1	;256usec reload
.def 	null	= r2	;immer 0
.def 	shiftl	= r4	;Empfangsregister L
.def 	shifth	= r5	;Empfangsregister H
.def 	rc5_time= r6	;Zeitstempel
.def 	rc5_bit	= r7	;Bit PD2

.def 	BAlb	= r8	; low byte for ASCII conversion
.def 	BAhb	= r9	;high byte for ASCII conversion
.def 	Divlb	= r10	;Divisor low byte for ASCII conversion
.def 	Divhb	= r11	;Divisor high byte for ASCII conversion

.def 	Asc1	= r12	;1. ASCII-Zeichen
.def 	Asc2	= r13	;2. ASCII-Zeichen
.def 	Asc3	= r14	;3. ASCII-Zeichen

.def 	temp	= r16	;
.def	temp1	= r17	;
.def	temp3	= r18	;
.def 	wl		= r19	;RC5 working reg L
.def 	wh		= r20	;RC5 working reg H
.def	rmp		= r21	;byte-ASCII working reg

; REGVAREND

;----------------------------------------------------------------------
; Memory variables
;----------------------------------------------------------------------
; RAMSTART

	.dseg						; switch to datasegment

rc5_datal:	.byte 	1
rc5_datah:	.byte 	1


; RAMEND

;----------------------------------------------------------------------
; Eeprom variables
;----------------------------------------------------------------------
; EEPROMSTART

	.eseg						; switch to Eeprom segment

; EEPROMEND

;----------------------------------------------------------------------
; Code variables
;----------------------------------------------------------------------
; CODESTART

	.cseg			; switch to Code segment
welcome:	.db	0x0D,0x0A,"* RC5 IR-Fernbedienung *",0x0D,0x0A 
			.db "Dipl.Ing. H.Krause @2008",0x0D,0x0A
			.db 0x0D,0x0A,0x00,0x00
sendline:	.db	0x0D,0x0A,"Taste > ",0x00, 0x00		; 


; CODEEND


